﻿###########################################################
#
#                  Asociativní zákon
# 
# Příklad ukazuje, že při počítání s reálnými čísly nemusí 
# platit asociativní zákon. Při výpočtu prvního výrazu se 
# nejprve odečtou dvě stejné hodnoty a k nim se přičte z, 
# takže výsledek je z.
# Při výpočtu druhého výrazu se při odečítání y - z
# číslo z zaokrouhlí za 0, takže výsledek bude 0 
# 
########################################################### 
import sys

def main()->int:
    x: float = 1e10
    y: float = 1e10
    z: float = 1e-10
    print("Následující příklad ukazuje, že pro reálná čísla nemusí platit asociativní zákon:")
    print(f"x: {x}, y: {y}, z: {z}")
    print(f"x - y + z = {x - y + z}")
    print(f"x - (y - z) = {x - (y - z)}")
    print("A tento příklad ukazuje, že nemusí platit ani komutativní zákon:")
    print(f"x - y + z = {x - y + z}")
    print(f"x + z - y = {x + z - y}")
     
if __name__ == "__main__":
    sys.exit(main())