﻿###########################################################
# 
#                   Fibonacciova čísla 
#               
# Výpočet Fibonacciových čísel rekurzivně (složitost 
# exponenciální a výpočet Fibonacciových čísel nerekurzivně 
# (složitost O(n))
# Program vypočte desáté Finonacciovo číslo spočtené oběma 
# způsoby, u rekurzivní implementace vypíše i počet volání 
###########################################################
import sys

global počet
počet: int = 0

def fibonacci_rekurzivně(n)->int:
    """Fibonacciova čísla rekurzivně (programátorský horror)"""
    global počet
    počet += 1
    if (n == 0 ) or (n == 1): return n
    return fibonacci_rekurzivně(n-1) + fibonacci_rekurzivně(n-2)

def fibonacci(n)->int:
    """Fibonacciova čísla nerekurzivně """
    if (n == 0 ) or (n == 1): return n
    else:
        a, b = 0, 1
        for i in range(2, n+1):
            c = a + b
            a = b 
            b = c
        return c

def main()->int:
    print(f"{fibonacci_rekurzivně(10) = }; počet rekurzivních volání : {počet}")
    print(f"{fibonacci(10) = }")

if __name__ == '__main__':
    sys.exit(main())